v17rx.h File Reference

Go to the source code of this file.

## Typedefs

typedef struct v17_rx_state_s | v17_rx_state_t

## Functions

v17_rx_state_t * | v17_rx_init (v17_rx_state_t *s, int bit_rate, put_bit_func_t put_bit, void *user_data)
| Initialise a V.17 modem receive context.
int | v17_rx_restart (v17_rx_state_t *s, int bit_rate, int short_train)
| Reinitialise an existing V.17 modem receive context.
int | v17_rx_release (v17_rx_state_t *s)
| Release a V.17 modem receive context.
int | v17_rx_free (v17_rx_state_t *s)
| Free a V.17 modem receive context.
logging_state_t * | v17_rx_get_logging_state (v17_rx_state_t *s)
| Get the logging context associated with a V.17 modem receive context.
void | v17_rx_set_put_bit (v17_rx_state_t *s, put_bit_func_t put_bit, void *user_data)
| Change the put_bit function associated with a V.17 modem receive context.
void | v17_rx_set_modem_status_handler (v17_rx_state_t *s, modem_status_func_t handler, void *user_data)
| Change the modem status report function associated with a V.17 modem receive context.
| SPAN_DECLARE_NONSTD (int) v17_rx(v17_rx_state_t *s
| Process a block of received V.17 modem audio samples.
int | v17_rx_equalizer_state (v17_rx_state_t *s, complexf_t **coeffs)
| Get a snapshot of the current equalizer coefficients.
float | v17_rx_carrier_frequency (v17_rx_state_t *s)
float | v17_rx_symbol_timing_correction (v17_rx_state_t *s)
float | v17_rx_signal_power (v17_rx_state_t *s)
void | v17_rx_signal_cutoff (v17_rx_state_t *s, float cutoff)
void | v17_rx_set_qam_report_handler (v17_rx_state_t *s, qam_report_handler_t handler, void *user_data)

## Variables

const int16_t | amp []
const int16_t int | len

## Typedef Documentation

## v17_rx_state_t

typedef struct v17_rx_state_s v17_rx_state_t

V.17 modem receive side descriptor. This defines the working state for a single instance of a V.17 modem receiver.

## Function Documentation

## SPAN_DECLARE_NONSTD()

SPAN_DECLARE_NONSTD | ( | int |  | ) |

Process a block of received V.17 modem audio samples.

Get the next bit of data from a T.38 rate adapting non-ECM buffer context.

Get a bit of received non-ECM image data.

Get the next bit of a transmitted serial bit stream.

Fake processing of a missing block of received V.17 modem audio samples.

Process a block of received V.17 modem audio samples.

Parameters

  s | The modem context.
  amp | The audio sample buffer.
  len | The number of samples in the buffer.

Returns
  The number of samples unprocessed.

Fake processing of a missing block of received V.17 modem audio samples. (e.g due to packet loss).

Parameters

  s | The modem context.
  len | The number of samples to fake.

Returns
  The number of samples unprocessed.

## v17_rx_carrier_frequency()

float v17_rx_carrier_frequency | ( | v17_rx_state_t * | s | ) |

Get the current received carrier frequency.

Parameters

  s | The modem context.

Returns
  The frequency, in Hertz.

References v17_rx_state_s::carrier_phase_rate, and dds_frequencyf().

## v17_rx_equalizer_state()

int v17_rx_equalizer_state | ( | v17_rx_state_t * | s,
|  | complexf_t ** | coeffs )

Get a snapshot of the current equalizer coefficients.

Get a snapshot of the current equalizer coefficients.

Parameters

  s | The modem context.
  coeffs | The vector of complex coefficients.

Returns
  The number of coefficients in the vector.

References v17_rx_state_s::eq_coeff.

## v17_rx_free()

int v17_rx_free | ( | v17_rx_state_t * | s | ) |

Free a V.17 modem receive context.

Free a V.17 modem receive context.

Parameters

  s | The modem context.

Returns
  0 for OK

## v17_rx_get_logging_state()

logging_state_t * v17_rx_get_logging_state | ( | v17_rx_state_t * | s | ) |

Get the logging context associated with a V.17 modem receive context.

Get the logging context associated with a V.17 modem receive context.

Parameters

  s | The modem context.

Returns
  A pointer to the logging context

References v17_rx_state_s::logging.

## v17_rx_init()

v17_rx_state_t * v17_rx_init | ( | v17_rx_state_t * | s,
|  | int | bit_rate,
|  | put_bit_func_t | put_bit,
|  | void * | user_data )

Initialise a V.17 modem receive context.

Initialise a V.17 modem receive context.

Parameters

  s | The modem context.
  bit_rate | The bit rate of the modem. Valid values are 7200, 9600, 12000 and 14400.
  put_bit | The callback routine used to put the received data.
  user_data | An opaque pointer passed to the put_bit routine.

Returns
  A pointer to the modem context, or NULL if there was a problem.

References CARRIER_NOMINAL_FREQ, v17_rx_state_s::carrier_phase_rate_save, v17_rx_state_s::logging, v17_rx_state_s::put_bit, v17_rx_state_s::put_bit_user_data, v17_rx_state_s::short_train, v17_rx_restart(), and v17_rx_signal_cutoff().

## v17_rx_release()

int v17_rx_release | ( | v17_rx_state_t * | s | ) |

Release a V.17 modem receive context.

Release a V.17 modem receive context.

Parameters

  s | The modem context.

Returns
  0 for OK

## v17_rx_restart()

int v17_rx_restart | ( | v17_rx_state_t * | s,
|  | int | bit_rate,
|  | int | short_train )

Reinitialise an existing V.17 modem receive context.

Reinitialise an existing V.17 modem receive context.

Parameters

  s | The modem context.
  bit_rate | The bit rate of the modem. Valid values are 7200, 9600, 12000 and 14400.
  short_train | TRUE if a short training sequence is expected.

Returns
  0 for OK, -1 for bad parameter

References v17_rx_state_s::agc_scaling, v17_rx_state_s::agc_scaling_save, v17_rx_state_s::angles, v17_rx_state_s::baud_half, v17_rx_state_s::baud_phase, v17_rx_state_s::bit_rate, v17_rx_state_s::bits_per_symbol, v17_rx_state_s::carrier_drop_pending, CARRIER_NOMINAL_FREQ, v17_rx_state_s::carrier_phase, v17_rx_state_s::carrier_phase_rate, v17_rx_state_s::carrier_phase_rate_save, v17_rx_state_s::carrier_track_i, v17_rx_state_s::carrier_track_p, v17_rx_state_s::constellation, dds_frequencyf(), v17_rx_state_s::diff, v17_rx_state_s::distances, v17_rx_state_s::full_path_to_past_state_locations, v17_rx_state_s::high_sample, v17_rx_state_s::last_sample, v17_rx_state_s::logging, v17_rx_state_s::low_samples, v17_rx_state_s::past_state_locations, v17_rx_state_s::power, power_meter_init(), v17_rx_state_s::rrc_filter, v17_rx_state_s::rrc_filter_step, v17_rx_state_s::scramble_reg, v17_rx_state_s::short_train, v17_rx_state_s::signal_present, v17_rx_state_s::space_map, span_log(), v17_rx_state_s::start_angles, v17_rx_state_s::symbol_sync_dc_filter, v17_rx_state_s::symbol_sync_high, v17_rx_state_s::symbol_sync_low, v17_rx_state_s::total_baud_timing_correction, v17_rx_state_s::training_count, v17_rx_state_s::training_error, v17_rx_state_s::training_stage, and v17_rx_state_s::trellis_ptr.

Referenced by v17_rx_init().

## v17_rx_set_modem_status_handler()

void v17_rx_set_modem_status_handler | ( | v17_rx_state_t * | s,
|  | modem_status_func_t | handler,
|  | void * | user_data )

Change the modem status report function associated with a V.17 modem receive context.

Change the modem status report function associated with a V.17 modem receive context.

Parameters

  s | The modem context.
  handler | The callback routine used to report modem status changes.
  user_data | An opaque pointer.

References v17_rx_state_s::status_handler, and v17_rx_state_s::status_user_data.

## v17_rx_set_put_bit()

void v17_rx_set_put_bit | ( | v17_rx_state_t * | s,
|  | put_bit_func_t | put_bit,
|  | void * | user_data )

Change the put_bit function associated with a V.17 modem receive context.

Change the put_bit function associated with a V.17 modem receive context.

Parameters

  s | The modem context.
  put_bit | The callback routine used to handle received bits.
  user_data | An opaque pointer.

References v17_rx_state_s::put_bit, and v17_rx_state_s::put_bit_user_data.

## v17_rx_set_qam_report_handler()

void v17_rx_set_qam_report_handler | ( | v17_rx_state_t * | s,
|  | qam_report_handler_t | handler,
|  | void * | user_data )

Set a handler routine to process QAM status reports

Parameters

  s | The modem context.
  handler | The handler routine.
  user_data | An opaque pointer passed to the handler routine.

References v17_rx_state_s::qam_report, and v17_rx_state_s::qam_user_data.

## v17_rx_signal_cutoff()

void v17_rx_signal_cutoff | ( | v17_rx_state_t * | s,
|  | float | cutoff )

Set the power level at which the carrier detection will cut in

Parameters

  s | The modem context.
  cutoff | The signal cutoff power, in dBm0.

References v17_rx_state_s::carrier_off_power, v17_rx_state_s::carrier_on_power, and power_meter_level_dbm0().

Referenced by v17_rx_init().

## v17_rx_signal_power()

float v17_rx_signal_power | ( | v17_rx_state_t * | s | ) |

Get a current received signal power.

Parameters

  s | The modem context.

Returns
  The signal power, in dBm0.

References v17_rx_state_s::power, and power_meter_current_dbm0().

## v17_rx_symbol_timing_correction()

float v17_rx_symbol_timing_correction | ( | v17_rx_state_t * | s | ) |

Get the current symbol timing correction since startup.

Parameters

  s | The modem context.

Returns
  The correction.

References v17_rx_state_s::total_baud_timing_correction.